unit UMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.TabControl, FMX.StdCtrls, FMX.Controls.Presentation,
  FMX.Gestures, System.Actions, FMX.ActnList, FMX.Layouts, FMX.ListBox,
  FMX.MultiView, System.ImageList, FMX.ImgList, FrameItem, FMX.ScrollBox,
  FMX.Memo, FMX.ListView.Types, FMX.ListView.Appearances,
  FMX.ListView.Adapters.Base, Data.Bind.GenData, System.Rtti,
  System.Bindings.Outputs, Fmx.Bind.Editors, Data.Bind.EngExt,
  Fmx.Bind.DBEngExt, Data.Bind.Components, Data.Bind.ObjectScope, FMX.ListView,
  FMX.Objects, FMX.Effects, FMX.Edit, FMX.Filter.Effects;

type

  TMainForm = class(TForm)
    tcPerfiles: TTabControl;
    tiAbout: TTabItem;
    tiSeleccionar: TTabItem;
    tiPerfiles: TTabItem;
    ToolBar2: TToolBar;
    btnBack: TSpeedButton;
    GestureManager1: TGestureManager;
    ActionList1: TActionList;
    NextTabAction1: TNextTabAction;
    PreviousTabAction1: TPreviousTabAction;
    mvMain: TMultiView;
    ToolBar3: TToolBar;
    btnMasterButton: TButton;
    lbOpciones: TListBox;
    ListBoxItem1: TListBoxItem;
    ListBoxItem2: TListBoxItem;
    ListBoxItem3: TListBoxItem;
    ListBoxItem4: TListBoxItem;
    ilMain: TImageList;
    ListBoxHeader1: TListBoxHeader;
    Label1: TLabel;
    lblTitulo: TLabel;
    Label2: TLabel;
    cbPerfiles: TComboBox;
    Memo1: TMemo;
    tiAnyadir: TTabItem;
    ListBoxItem5: TListBoxItem;
    btnGuardar: TSpeedButton;
    ToolBar1: TToolBar;
    btnVolver: TSpeedButton;
    btnGuardar2: TSpeedButton;
    lvPerfiles: TListView;
    Rectangle1: TRectangle;
    rectAbout: TRectangle;
    imgAbout: TImage;
    Label3: TLabel;
    lblLink: TLabel;
    ShadowEffect1: TShadowEffect;
    Rectangle2: TRectangle;
    Label5: TLabel;
    edtNombre: TEdit;
    BlurEffect1: TBlurEffect;
    frVoz: TfrItem;
    frAlarma: TfrItem;
    frMultimedia: TfrItem;
    frNotificaciones: TfrItem;
    frVozNew: TfrItem;
    frAlarmaNew: TfrItem;
    frMultimediaNew: TfrItem;
    frNotificacionesNew: TfrItem;
    Rectangle3: TRectangle;
    Image1: TImage;
    Image2: TImage;
    Label6: TLabel;
    btnBorrar: TSpeedButton;
    Rectangle4: TRectangle;
    Rectangle5: TRectangle;
    Image3: TImage;
    Rectangle6: TRectangle;
    Image4: TImage;
    Rectangle7: TRectangle;
    procedure FormShow(Sender: TObject);
    procedure cbPerfilesChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnGuardarClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure lvPerfilesItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure btnGuardar2Click(Sender: TObject);
    procedure btnVolverClick(Sender: TObject);
    procedure btnBorrarClick(Sender: TObject);
    procedure tcPerfilesChange(Sender: TObject);
    procedure lblLinkClick(Sender: TObject);
    procedure lbOpcionesChange(Sender: TObject);
  private
    // FListaPerfiles: TListaPerfiles;
    FListaPerfiles:TPerfiles;
    function PathFicheroIni():string;

//    function GetVolValue(pVolumeValues:TVolumeValues; pIndex:integer):TVolumeValue;
//    function GetMaxVolumen(pStreamType:TStreamType):single;

    // Carga los perfiles existentes en la lista
    procedure CargarPerfilesExistentes();
//    procedure CargarPerfiles(pParent: TFmxObject; pType:TFrameType);
//    function CrearFrameVolumen(pParent: TFmxObject; pCaption:String; pIndex:integer;
//                               pVol:TVolumeValue; pType:TFrameType):TfrItem;
    function GetVolumeValuesByName(pNamePerfil:string):TVolumeValues;
    procedure CambiarEstadoFramesModif(Activar:boolean);

    procedure LimpiarFramesNew();

    procedure OcultarVisualizarFrames(pVisible:boolean);
    // cargar valores de un perfil en los Frames
    procedure CargarValoresFrames(pNombrePerfil:string);
    procedure ActivarPerfil(pNombrePerfil:string);
  public
    property ListaPerfiles:TPerfiles read FListaPerfiles write FListaPerfiles;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.fmx}

uses
 IdURI,
{$IFDEF ANDROID}
  Androidapi.Helpers, FMX.Helpers.Android, Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.App, Androidapi.JNI.Net, Androidapi.JNI.JavaTypes, Androidapi.JNIBridge,
  AndroidApi.Jni.Media
{$ENDIF ANDROID}

{$IFDEF MSWINDOWS}
  Winapi.ShellAPI, Winapi.Windows
{$ENDIF MSWINDOWS}

  ,System.IOUtils, IniFiles;


procedure TMainForm.btnGuardar2Click(Sender: TObject);
var
  sName:string;
  i, count:integer;
  p:TPerfil;
begin
  sName := Trim(edtNombre.Text);
  // Guardar el nuevo perfil
  i := ListaPerfiles.IndexOf(sName);
  if (i >= 0) then begin
    ShowMessage('Ya existe un perfil con ese nombre.');
    Exit;
  end;

  // Aadir un perfil a la lista
  p := TPerfil.Create();
  p.Nombre := sName;
  // Volumenes
  p.fVolumeValues.Notificaciones.Value := frNotificacionesNew.tbValor.Value;
  p.fVolumeValues.Notificaciones.MaxValue := frNotificacionesNew.tbValor.Max;

  p.fVolumeValues.Multimedia.Value := frMultimediaNew.tbValor.Value;
  p.fVolumeValues.Multimedia.MaxValue := frMultimediaNew.tbValor.Max;

  p.fVolumeValues.Alarma.Value := frAlarmaNew.tbValor.Value;
  p.fVolumeValues.Alarma.MaxValue := frAlarmaNew.tbValor.Max;

  p.fVolumeValues.Voz.Value := frVozNew.tbValor.Value;
  p.fVolumeValues.Voz.MaxValue := frVozNew.tbValor.Max;

  // Aadirlo
  ListaPerfiles.AddPerfil(p);
  // Grabar
  ListaPerfiles.SaveToFile;

  ShowMessage('Se ha grabado el perfil correctamente.');

  // Limpiar y colocar al inicio
  LimpiarFramesNew();
  edtNombre.Text := '';
  edtNombre.SetFocus;

  // Volverlos a cargar
  CargarPerfilesExistentes();
  // Cargar el combobox la lista de perfiles
  cbPerfiles.Items.Text := ListaPerfiles.Text;
end;

procedure TMainForm.btnGuardarClick(Sender: TObject);
var
  p:TPerfil;
begin
//  CambiarEstadoFramesModif(False);
  // Guardar el estado
  p := ListaPerfiles.GetPerfilByName(cbPerfiles.Items[cbPerfiles.ItemIndex]);
  // encontrado?
  if Assigned(p) then begin
    p.FVolumeValues.Notificaciones.Value := frNotificaciones.Valor;
    p.FVolumeValues.Multimedia.Value := frMultimedia.Valor;
    p.FVolumeValues.Alarma.Value := frAlarma.Valor;
    p.FVolumeValues.Voz.Value := frVoz.Valor;
  end;
  ListaPerfiles.UpdatePerfil(p);

end;




procedure TMainForm.btnVolverClick(Sender: TObject);
begin
  LimpiarFramesNew();
  // Si se pulsa con el botn
  if Assigned(Sender) then begin
    tcPerfiles.ActiveTab := tiPerfiles;
  end;
end;


procedure TMainForm.CambiarEstadoFramesModif(Activar: boolean);
begin
  frNotificaciones.Enabled := Activar;
  frMultimedia.Enabled := Activar;
  frAlarma.Enabled := Activar;
  frVoz.Enabled := Activar;
end;



procedure TMainForm.ActivarPerfil(pNombrePerfil: string);
var
  i:integer;
  vol:TVolumeValues;
  s:single;
begin

  BlurEffect1.Enabled := true;
  try
    i := ListaPerfiles.IndexOf(pNombrePerfil);
    if (i <> -1) then begin
      // Activarlo...
      vol := GetVolumeValuesByName(pNombrePerfil);

      // para cada elemento activarlo...
      // Hay que activar segun porcentage, no el que vemos en la barra
      s := GetMaxVolumen(stNotificaciones);
      s := (s * vol.Notificaciones.Value) / vol.Notificaciones.MaxValue;
      SetVolumen(s, stNotificaciones);

      s := GetMaxVolumen(stMultimedia);
      s := (s * vol.Multimedia.Value) / vol.Multimedia.MaxValue;
      SetVolumen(s, stMultimedia);

      s := GetMaxVolumen(stAlarma);
      s := (s * vol.Alarma.Value) / vol.Alarma.MaxValue;
      SetVolumen(s, stAlarma);

      s := GetMaxVolumen(stVoz);
      s := (s * vol.Voz.Value) / vol.Voz.MaxValue;
      SetVolumen(s, stVoz);

    end;
  finally
    BlurEffect1.Enabled := False;
  end;
end;

procedure TMainForm.btnBackClick(Sender: TObject);
begin
  // editar
  btnGuardar.Enabled := False;
  // El combo porner a -1
  cbPerfiles.ItemIndex := -1;
  // Ocultar Frames
  OcultarVisualizarFrames(False);
  // desde el boton...
  if Assigned(Sender) then begin
    tcPerfiles.ActiveTab := tiPerfiles;
  end;
end;

procedure TMainForm.btnBorrarClick(Sender: TObject);
var
  res:integer;
  p:TPerfil;
begin
  // Borrar el perfil
  //res := MessageDlg('Realmente desea eliminar este perfil?', TMsgDlgType.mtConfirmation,
  //          [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0);
  res := mrYes;
  if (res = mrYes) then begin
    // borrar perfil
    p := ListaPerfiles.GetPerfilByName(cbPerfiles.Items[cbPerfiles.ItemIndex]);
    if Assigned(p) then begin
      ListaPerfiles.DeletePerfil(p);
      // Volverlos a cargar
      CargarPerfilesExistentes();
      // Cargar el combobox la lista de perfiles
      cbPerfiles.Items.Text := ListaPerfiles.Text;
    end;

    // Volver a la pantalla principal
    tcPerfiles.ActiveTab := tiPerfiles;
  end;

end;

procedure TMainForm.btnEditarClick(Sender: TObject);
begin

end;


// Carga los perfiles en la lista (para seleccionar)
procedure TMainForm.CargarPerfilesExistentes();
var
  I: Integer;
  li:TListViewItem;
begin
  // Limpiar los que haya
  lvPerfiles.Items.Clear;

  // Aadir los nuevos...
  for I := 0 to (ListaPerfiles.Count - 1) do begin
    li := lvPerfiles.Items.Add;
    li.Text := ListaPerfiles.Nombre[I];
  end;
end;


{
procedure TMainForm.CargarPerfiles(pParent: TFmxObject; pType:TFrameType);
var
  iniF:TInifile;
  fName:String;
  TS:TStrings;
  i:integer;
  vol:TVolumeValues;
  volValue:TVolumeValue;
  fr:TfrItem;
begin
  fName := PathFicheroIni();
  if FileExists(fName) then begin
    iniF := TInifile.Create(fName);
    TS := TStringList.Create();

    iniF.ReadSections(TS);
    for i := 0 to (TS.Count - 1) do begin
      // Memo1.Lines.Add(TS[i]);

      vol.Notificaciones.Value := iniF.ReadInteger(TS[i], 'Notificaciones', 50);
      vol.Notificaciones.MaxValue := GetMaxVolumen(stNotificaciones);
      vol.Multimedia.Value := iniF.ReadInteger(TS[i], 'Multimedia', 50);
      vol.Multimedia.MaxValue := GetMaxVolumen(stMultimedia);
      vol.Alarma.Value := iniF.ReadInteger(TS[i], 'Alarma', 50);
      vol.Alarma.MaxValue := GetMaxVolumen(stAlarma);
      vol.Voz.Value := iniF.ReadInteger(TS[i], 'Voz', 50);
      vol.Voz.MaxValue := GetMaxVolumen(stVoz);

      volValue := GetVolValue(vol, i);

      // Para cada uno Crear un Frame
      //-v2- fr := CrearFrameVolumen(pParent, TS[i], i, volValue, pType);

      // Aadirlo a la lista de perfiles, solo los de modif...
      //-v2-
      // if (pType = ftModif) then begin
      //   ListaPerfiles.AddFrame(TS[i], fr);
      // end;
    end;
  end
  else begin
    ShowMessage('No hay perfiles definidos');
  end;
end;
}

// cargar valores de un perfil en los Frames
procedure TMainForm.CargarValoresFrames(pNombrePerfil: string);
var
  p:TPerfil;
begin
  p := ListaPerfiles.GetPerfilByName(pNombrePerfil);
  if Assigned(p) then begin
    frNotificaciones.tbValor.Value := p.VolumeValues.Notificaciones.Value;
    frNotificaciones.tbValor.Max := p.VolumeValues.Notificaciones.MaxValue;

    frMultimedia.tbValor.Value := p.VolumeValues.Multimedia.Value;
    frMultimedia.tbValor.Max := p.VolumeValues.Multimedia.MaxValue;

    frAlarma.tbValor.Value := p.VolumeValues.Alarma.Value;
    frAlarma.tbValor.Max := p.VolumeValues.Alarma.MaxValue;

    frVoz.tbValor.Value := p.VolumeValues.Voz.Value;
    frVoz.tbValor.Max := p.VolumeValues.Voz.MaxValue;
  end;
end;


procedure TMainForm.cbPerfilesChange(Sender: TObject);
var
  i, j: Integer;
  pName:String;
  fr:TfrItem;
  vol:TVolumeValues;
  v:TVolumeValue;
begin
  // Cambiar el valor
  if (cbPerfiles.ItemIndex = -1) then begin
    // Todos ocultos
    OcultarVisualizarFrames(False);
    btnGuardar.Enabled := False;
    btnBorrar.Enabled := False;
  end
  else begin
    OcultarVisualizarFrames(True);
    btnGuardar.Enabled := True;
    btnBorrar.Enabled := True;
    CargarValoresFrames(cbPerfiles.Items[cbPerfiles.ItemIndex]);
  end;
end;

//-v2-
{
function TMainForm.CrearFrameVolumen(pParent: TFmxObject; pCaption: String; pIndex: integer;
                                     pVol:TVolumeValue; pType:TFrameType):TfrItem;
var
  fr:TfrItem;
begin
  fr := TfrItem.Create(nil);
  fr.Name := pParent.Name + 'Frame' + IntToStr(pIndex);
  fr.Parent := pParent;
  fr.Position.Y := (pIndex * fr.Height) + 10;
  fr.Align := TAlignLayout.Top;
  // Propiedades
  fr.Titulo := pCaption;
  // Volumen maximo
  fr.ValorMax := pVol.MaxValue;

  // Slo asignamos el valor si estamos modificando
  if (pType = ftModif) then begin
    fr.Valor := pVol.Value;
  end;

  fr.StreamType := TStreamType(pIndex);
  fr.FrameType := pType;

  // Habilitar el control de trackbar
  fr.tbValor.Enabled := True;

  Result := fr;

end;
}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  // Crear la lista de perfiles
  ListaPerfiles := TPerfiles.Create(PathFicheroIni());
  ListaPerfiles.Duplicates := dupError;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  TS:tStrings;
  str:string;
begin
  // Config inicial
  mvMain.Mode := TMultiViewMode.Drawer;
  lbOpciones.Align := TAlignLayout.Client;

  // Activar la primera pestaa
  lbOpciones.ItemIndex := 0;
  tcPerfiles.ActiveTab := tiPerfiles;

  //------------------------------------------------------------------
  TS := TStringList.Create;
  TS.Add('[Silencio total]');
  TS.Add('Notificaciones=0');
  TS.Add('Multimedia=0');
  TS.Add('Alarma=0');
  TS.Add('Voz=0');
  Str := PathFicheroIni();
  if not FileExists(Str) then begin
    TS.SaveToFile(str);
  end;
  TS.Free;
  //------------------------------------------------------------------

  // Cargar perfiles de disco
  ListaPerfiles := TPerfiles.Create(PathFicheroIni());
  if FileExists(PathFicheroIni()) then
    ListaPerfiles.LoadFromFile;

  // Cargar el combobox la lista de perfiles
  cbPerfiles.Items.Text := ListaPerfiles.Text;
  // ninguno seleccionado
  lbOpcionesChange(nil);
  // cargar en la lista para seleccionar los perfiles existentes
  CargarPerfilesExistentes();

end;

{
function TMainForm.GetVolumeValuesByName(pNamePerfil: string): TVolumeValues;
var
  iniF:TiniFile;
  fName:String;
  TS:TStringList;
begin

  fName := PathFicheroIni();
  if FileExists(fName) then begin
    iniF := TInifile.Create(fName);
    TS := TStringList.Create();
    try
      Result.Notificaciones.Value := iniF.ReadInteger(pNamePerfil, 'Notificaciones', 0);
      Result.Multimedia.Value := iniF.ReadInteger(pNamePerfil, 'Multimedia', 0);
      Result.Alarma.Value := iniF.ReadInteger(pNamePerfil, 'Alarma', 0);
      Result.Voz.Value := iniF.ReadInteger(pNamePerfil, 'Voz', 0);

      // maximos
      Result.Notificaciones.MaxValue := GetMaxVolumen(stNotificaciones);
      Result.Multimedia.MaxValue := GetMaxVolumen(stMultimedia);
      Result.Alarma.MaxValue := GetMaxVolumen(stAlarma);
      Result.Voz.MaxValue := GetMaxVolumen(stVoz);

    finally
      FreeAndNil(TS);
      FreeAndNil(iniF);
    end;
  end;
end;
}

function TMainForm.GetVolumeValuesByName(pNamePerfil: string): TVolumeValues;
var
  index:integer;
begin
  index := ListaPerfiles.IndexOf(pNamePerfil);
  if (index >= 0) then begin
    Result := ListaPerfiles.Perfil[index].VolumeValues;
  end;
end;

{
function TMainForm.GetVolValue(pVolumeValues:TVolumeValues; pIndex:integer): TVolumeValue;
begin
  case pIndex of
    1:  Result := pVolumeValues.Notificaciones;
    2:  Result := pVolumeValues.Multimedia;
    3:  Result := pVolumeValues.Alarma;
    4:  Result := pVolumeValues.Voz;
  end;
end;
}

procedure TMainForm.lblLinkClick(Sender: TObject);
var
  myURL: string;
{$IFDEF ANDROID}
  Intent: JIntent;
{$ENDIF ANDROID}

begin
  myURL := 'http://neftali.clubdelphi.com';
{$IFDEF MSWINDOWS}
  ShellExecute(0, 'OPEN', PChar(myURL), '', '', SW_SHOWNORMAL);
{$ENDIF MSWINDOWS}

{$IFDEF ANDROID}
  Intent := TJIntent.Create;
  Intent.setAction(TJIntent.JavaClass.ACTION_VIEW);
  Intent.setData(StrToJURI(myURL));
  TAndroidHelper.Activity.startActivity(Intent);
{$ENDIF ANDROID}

end;

procedure TMainForm.lbOpcionesChange(Sender: TObject);
begin
  if (lbOpciones.ItemIndex > -1) then begin
    // Activamos una pgina u otra
    case lbOpciones.ItemIndex of
      0:  tcPerfiles.ActiveTab := tiPerfiles;
      1:  begin
            tcPerfiles.ActiveTab := tiSeleccionar;
            // Si es -1, ocultarlos
            if (cbPerfiles.ItemIndex = -1) then begin
              // ocultar los frames
              cbPerfilesChange(nil);
            end;
          end;
      2:  begin
            tcPerfiles.ActiveTab := tiAnyadir;
            LimpiarFramesNew;
          end;
      3:  tcPerfiles.ActiveTab := tiAbout;
      4:  Close;
    end;

    // Al cambiar de pestaa, cambiamos el titulo
    lblTitulo.Text := IntToStr(lbOpciones.ItemIndex);
    lblTitulo.Text := lbOpciones.Items[lbOpciones.ItemIndex];
    // pulsar los 2 volver para incializar
    btnVolverClick(nil);
    btnBackClick(nil);
  end;
  // Guardar el menu
  mvMain.HideMaster;
end;

procedure TMainForm.LimpiarFramesNew;
begin
  frNotificacionesNew.Inicializar;
  frMultimediaNew.Inicializar;
  frAlarmaNew.Inicializar;
  frVozNew.Inicializar;
end;

procedure TMainForm.lvPerfilesItemClick(const Sender: TObject;
  const AItem: TListViewItem);
begin
  ShowMessage('Activando perfil... ' + AItem.Text);
  ActivarPerfil(AItem.Text);
end;

procedure TMainForm.OcultarVisualizarFrames(pVisible: boolean);
begin
  frNotificaciones.Opacity := Integer(pVisible);
  frMultimedia.Opacity := Integer(pVisible);
  frAlarma.Opacity := Integer(pVisible);
  frVoz.Opacity := Integer(pVisible);
end;

function TMainForm.PathFicheroIni(): string;
begin
  Result := IncludeTrailingPathDelimiter(TPath.GetSharedDocumentsPath()) + 'Perfiles.ini';
end;


procedure TMainForm.tcPerfilesChange(Sender: TObject);
begin
  // Cambiar la lista...
  lbOpciones.ItemIndex := tcPerfiles.ActiveTab.Index;
end;

end.

